Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkAbstractPropPicker Class Reference

`#include <vtkAbstractPropPicker.h>`

Inheritance diagram for vtkAbstractPropPicker:

[legend]
Collaboration diagram for vtkAbstractPropPicker:

[legend]
List of all members.

## Detailed Description

abstract API for pickers that can pick an instance of vtkProp

Date:
  2002/05/28 03:33:50

Revision:
  1.13

vtkAbstractPropPicker is an abstract superclass for pickers that can pick an instance of vtkProp. Some pickers, like vtkWorldPointPicker (not a subclass of this class), cannot identify the prop that is picked. Subclasses of vtkAbstractPropPicker return a prop in the form of a vtkAssemblyPath when a pick is invoked. Note that an vtkAssemblyPath contain a list of vtkAssemblyNodes, each of which in turn contains a reference to a vtkProp and a 4x4 transformation matrix. The path fully describes the entire pick path, so you can pick assemblies or portions of assemblies, or just grab the tail end of the vtkAssemblyPath (which is the picked prop).

Warning:
  Because a vtkProp can be placed into different assemblies, or even in different leaf positions of the same assembly, the vtkAssemblyPath is used to fully qualify exactly which use of the vtkProp was picked, including its position (since vtkAssemblyPath includes a transformation matrix per node).

Warning:
  The class returns information about picked actors, props, etc. Note that what is returned by these methods is the top level of the assembly path. This can cause a lot of confusion! For example, if you pick a vtkAssembly, and the returned vtkAssemblyPath has as a leaf a vtkActor, then if you invoke GetActor(), you will get NULL, even though an actor was indeed picked. (GetAssembly() will return something.) Note that the safest thing to do is to do a GetProp(), which will always return something if something was picked. A better way to manage picking is to work with vtkAssemblyPath, since this completely defines the pick path from top to bottom in a assembly hierarchy, and avoids confusion when the same prop is used in different assemblies.

Warning:
  The returned assembly paths refer to assembly nodes that in turn refer to vtkProp and vtkMatrix. This association to vtkProp is not a reference counted association, meaning that dangling references are possible if you do a pick, get an assembly path, and then delete a vtkProp. (Reason: assembly paths create many self-referencing loops that destroy reference counting.)

See also:
  vtkPropPicker vtkPicker vtkWorldPointPicker vtkCellPicker vtkPointPicker vtkAssemblyPath vtkAssemblyNode vtkAssemblyPaths vtkAbstractPicker vtkRenderer

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (85%)
  - Cedilnik, Andy (7%)
  - Martin, Ken (6%)

CVS logs (CVSweb):
  - .`cxx` (`/Rendering/vtkAbstractPropPicker.cxx)`
  - .`h` (`/Rendering/vtkAbstractPropPicker.h)`

Definition at line 93 of file vtkAbstractPropPicker.h.

## Public Types
typedef vtkAbstractPicker | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
virtual vtkProp * | GetProp ()
virtual vtkProp3D * | GetProp3D ()
virtual vtkActor * | GetActor ()
virtual vtkActor2D * | GetActor2D ()
virtual vtkVolume * | GetVolume ()
virtual vtkAssembly * | GetAssembly ()
virtual vtkPropAssembly * | GetPropAssembly ()
virtual void | SetPath (vtkAssemblyPath *)
virtual vtkAssemblyPath * | GetPath ()
## Static Public Methods
int | IsTypeOf (const char *type)
vtkAbstractPropPicker * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkAbstractPropPicker ()
| ~vtkAbstractPropPicker ()
void | Initialize ()
## Protected Attributes
vtkAssemblyPath * | Path

## Member Typedef Documentation

typedef vtkAbstractPicker vtkAbstractPropPicker::Superclass

| Reimplemented from vtkAbstractPicker. Reimplemented in vtkCellPicker, vtkPicker, vtkPointPicker, and vtkPropPicker. Definition at line 96 of file vtkAbstractPropPicker.h.

## Constructor & Destructor Documentation

vtkAbstractPropPicker::vtkAbstractPropPicker | ( |  | ) | `[protected]`

vtkAbstractPropPicker::~vtkAbstractPropPicker | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkAbstractPropPicker::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkAbstractPicker. Reimplemented in vtkCellPicker, vtkPicker, vtkPointPicker, and vtkPropPicker.

int vtkAbstractPropPicker::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkAbstractPicker. Reimplemented in vtkCellPicker, vtkPicker, vtkPointPicker, and vtkPropPicker.

virtual int vtkAbstractPropPicker::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkAbstractPicker. Reimplemented in vtkCellPicker, vtkPicker, vtkPointPicker, and vtkPropPicker.

vtkAbstractPropPicker* vtkAbstractPropPicker::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkAbstractPicker. Reimplemented in vtkCellPicker, vtkPicker, vtkPointPicker, and vtkPropPicker.

void vtkAbstractPropPicker::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkAbstractPicker. Reimplemented in vtkCellPicker, vtkPicker, vtkPointPicker, and vtkPropPicker.

virtual void vtkAbstractPropPicker::SetPath | ( | vtkAssemblyPath * |  | ) | `[virtual]`

| Return the vtkAssemblyPath that has been picked. The assembly path lists all the vtkProps that form an assembly. If no assembly is present, then the assembly path will have one node (which is the picked prop). The set method is used internally to set the path. (Note: the structure of an assembly path is a collection of vtkAssemblyNode, each node pointing to a vtkProp and (possibly) a transformation matrix.)

virtual vtkAssemblyPath* vtkAbstractPropPicker::GetPath | ( |  | ) | `[virtual]`

| Return the vtkAssemblyPath that has been picked. The assembly path lists all the vtkProps that form an assembly. If no assembly is present, then the assembly path will have one node (which is the picked prop). The set method is used internally to set the path. (Note: the structure of an assembly path is a collection of vtkAssemblyNode, each node pointing to a vtkProp and (possibly) a transformation matrix.)

virtual vtkProp* vtkAbstractPropPicker::GetProp | ( |  | ) | `[virtual]`

| Return the vtkProp that has been picked. If NULL, nothing was picked. If anything at all was picked, this method will return something.

virtual vtkProp3D* vtkAbstractPropPicker::GetProp3D | ( |  | ) | `[virtual]`

| Return the vtkProp that has been picked. If NULL, no vtkProp3D was picked.

virtual vtkActor* vtkAbstractPropPicker::GetActor | ( |  | ) | `[virtual]`

| Return the vtkActor that has been picked. If NULL, no actor was picked.

virtual vtkActor2D* vtkAbstractPropPicker::GetActor2D | ( |  | ) | `[virtual]`

| Return the vtkActor2D that has been picked. If NULL, no actor2D was picked.

virtual vtkVolume* vtkAbstractPropPicker::GetVolume | ( |  | ) | `[virtual]`

| Return the vtkVolume that has been picked. If NULL, no volume was picked.

virtual vtkAssembly* vtkAbstractPropPicker::GetAssembly | ( |  | ) | `[virtual]`

| Return the vtkAssembly that has been picked. If NULL, no assembly was picked. (Note: the returned assembly is the first node in the assembly path. If the path is one node long, then the assembly and the prop are the same, assuming that the first node is a vtkAssembly.)

virtual vtkPropAssembly* vtkAbstractPropPicker::GetPropAssembly | ( |  | ) | `[virtual]`

| Return the vtkPropAssembly that has been picked. If NULL, no prop assembly was picked. (Note: the returned prop assembly is the first node in the assembly path. If the path is one node long, then the prop assembly and the prop are the same, assuming that the first node is a vtkPropAssembly.)

void vtkAbstractPropPicker::Initialize | ( |  | ) | `[protected, virtual]`

| Reimplemented from vtkAbstractPicker. Reimplemented in vtkCellPicker, vtkPicker, vtkPointPicker, and vtkPropPicker.

## Member Data Documentation

vtkAssemblyPath* vtkAbstractPropPicker::Path`[protected]`

| Definition at line 156 of file vtkAbstractPropPicker.h.

The documentation for this class was generated from the following file:

- Rendering/vtkAbstractPropPicker.h